// Cyrille Henry 2010

//#extension GL_ARB_texture_rectangle : enable
//uniform sampler2DRect MyTex;
uniform sampler2D MyTex;
uniform vec2 overlap, geometry;

void main (void)
{
    vec2 coord = (gl_TextureMatrix[0] * gl_TexCoord[0]).st;
    vec2 pos = coord;
    pos *= geometry;
    vec2 pos_over = fract(pos);
    pos_over *= overlap;
    pos_over -= overlap/2.;
    pos += pos_over;
    pos += overlap/2.;
    pos /= geometry + overlap;
    vec4 color = texture2D(MyTex, pos);


    vec2 black = coord;
    black *= geometry;
    black = fract(black);
    black *= vec2(1.)+overlap;
    black -= 1.;
    black = max(black,0.)/overlap;
    if (geometry.x != ceil(coord*geometry).x)
        color *= (1.-black.x);
    if (geometry.y != ceil(coord*geometry).y)
        color *= (1.-black.y);

    black = coord;
    black *= geometry;
    black = fract(black);
    black *= vec2(1.)+overlap;
    black -= overlap;
    black = max(-black,0.)/overlap;
    if (1. != ceil(coord*geometry).x)
        color *= (1.-black.x);
    if (1. != ceil(coord*geometry).y)
        color *= (1.-black.y);

    gl_FragColor = color;
}
